/*  Tests for basic parallel multiple-precision integer arithmetic	*/
/*  Source: pitest.c	Ernest Sibert	February 1995		*/
/*  Lisa Thornhill  June 1995                          */

#include <stdio.h>
#include <stdlib.h>
#include "miarith.h"
#include "multip.h"
#include "midec.h"
#include "midiv.h"
#include "pmiarith.h"
#include "pmidec.h"
#include "miglob.h"

#define size 4


shape [size] ptest;


void load_multi(int x[],int  N)    /* sequential multi prec. funct.  */ 
 { int i;
   for ( i = 0;  i <= N;  i++) scanf("%i", &x[i]);
 }

/*  Print multi-number in hex to standard output:  status word(1) .. word(N) */
/*  Issues no new-lines							     */

void prin_multx(int x[], int N)
 { int i;
   for ( i = 0;  i <= N;  i++ ) printf("0x%08x ", x[i]);
 }

/* Maximum precision for testing, array dimension */
#define Nt 6
#define Nd (Nt+1)
#define N2 (2*Nt + 1)

/*  Interactive tests */

void main()
 { int w[Nd], N, m, n, d;
   int:ptest x[Nd], y[Nd], z[Nd], zz[N2], zw[N2], pw[Nd], *rem, pstat;
   char buff[80];
   N = Nt;		/* Largest allowed value */
   with (ptest) everywhere 
   while ( printf("pitest > "),
	   scanf("%s", buff),
	   buff[0] != 'q'         )
    { switch ( buff[0] )
       { case 'n':  scanf("%i", &n);
		    if ( (1 <= n) && (n <= Nt) ) N = n;
		     else printf("Value out of range.\n");
   		    break;
	 case 'x':  load_multi(w, N); mp2pmp(x,w,N);   break;
     case 'y':  load_multi(w, N); mp2pmp(y,w,N);  break;
	 case '+':  pimadd(z, x, y, N); pmp2mp(w,z,N,0);  prin_multx(w, N); 
                printf("\n"); break;
	 case '-':  pimsub(z, x, y, N); pmp2mp(w,z,N,0);  prin_multx(w, N);
                printf("\n");  break;
	 case 'p':  scanf ("%i%i", &m, &n);
                pimup(z, x, m, n); pmp2mp(w,z,m,0);  prin_multx(w, m);
				printf("\n");  break;
	 case 'm':  scanf ("%i", &m);
                pint2pmi(z, N,(int:current) m); pmp2mp(w,z,N,0);
            	prin_multx(w, N);
				printf("\n");  break;
     case 'g':	imglbmin(w,x,N);  prin_multx(w, N);
				printf("\n");  break;
/*	 case 'X':  break; imult2(zz, x, y, N, N);  prin_multx(zz, 2*N);
	 	        printf("\n");  break;
	 case 't':  pmcopy(z, x, N);   scanf("%i%i", &n, &d); break;
		        immuls(z, N, n, d);   prin_multx(z, N);  printf("\n");
		        break;
	 case '2':  break;  mzero(z, 1);  mzero(w, 2);
		        z[1] = idiv2by1(x[1], x[2], y[1], &w[2]);
                    if ( z[1] ) z[0] = Nonzr;  if ( w[2] ) w[0] = Nonzr;
		        imult2(zz, z, y, 1, 1);  imadd(zz, zz, w, 2);
		        printf("q:  0x%08x    r:  0x%08x    ok:  %d\n",
			         z[1],         w[2], !imcomp(x, zz, 2));
		        prin_multx(zz, 2);  printf("\n");  break;          */
	 case 'D':  /* Currently for imdiv2x */ break;
	/*	    scanf("%i%i", &m, &n);  mcopy(zz, x, m);
		    printf("Dividend[0..%d]:  ", m);     prin_multx(zz, m);
                    printf("\nDivisor[0..%d]:   ", n);   prin_multx(y, n);
		    printf("\n");
                    imdiv2x(zz, y, z, &rem, zw, n, m-n);
		    printf("\nQuotient[0..%d]:  ", m-n); prin_multx(z, m-n);
		    printf("\nRemainder[0..%d]: ", n);   prin_multx(rem, n);
		    d = zz[m-n]; mzero(zz, m-n);  zz[0] = d;
		    printf("\nRemainder[0..%d]: ", m);   prin_multx(zz, m);
		    imult2x(zw, y, z, n, m-n);	/* quo * dvsr */
/*		    imadd(zw, zw, zz, m);	/* + rem      */
/*		    printf("\nCheck[0..%d]:     ", m);  prin_multx(zw, m);
		    printf("\n");  break;
	 case 'd': break; mcopy(z, x, N);  scanf("%i", &n);
		    imdivs(z, N, n, &d);  printf("Rem:  %d   Quo:\n", d);
		    prin_multx(z, N);  printf("\n");  break;                    */
	 case '~':  pimneg(z, x, N); pmp2mp(w, z, N, 0); prin_multx(w, N);
                printf("\n"); break;
	 case 'c': pmcopy(z, x, N); pmp2mp(w,z,N,0);  prin_multx(w, N); 
               printf("\n");
		    break;
	 case '0': pmzero(z, N); pmp2mp(w,z,N,0);  prin_multx(w, N);  printf("\n");
     	    break;
     case 's':  scanf("%i", &n);  pimshift(z, x, n, N);
                    pmp2mp(w,z,N,0);
		            prin_multx(w, N);  printf("\n");  break;
	 case 'u':  pstat = pimstat(x); printf("Status:  %d\n", [0]pstat);  break;
     case '#':  pstat = pimcomp(x,y,N); printf("x ? y:   %d\n",[0]pstat); break;
/*	 case 'b':  break; printf("Bitpos(x[1]):  %d\n", Bitpos(x[1])); break;
	 case 'r':  break;mcopy(z, x, N);  printf("shift:  %d\n", imnorm(z, N));
		    prin_multx(z, N);  printf("\n");  break;
*/
     case 'C':  if ( buff[1] == '1' )		/* m -> dec */
		     { pmp2mp(w,x,N,0); d = im2dec(w, N, buff, 10*N);
		       printf("Outcome: %d    Decimal result:\n", d);
		       printf("%s\n", buff);
		     }
		    else
		     { fgets(buff, 80,  stdin);  d = dec2im(w, N, buff);
		       printf("Outcome: %d    Hex, dec results:\n", d);
		       prin_multx(w, N);
		       d = im2dec(w, N, buff, 10*N + 1);
		       printf("\nOutcome: %d\n%s\n", d, buff);
		     }  break;
	 case '?':
printf(
"Commands are:   (<i> denotes integer in dec, oct, or hex )\n");
printf(
" n <i> :: set precision     x <i>... :: load x      y <i>... :: load y\n");
printf(
" + :: x + y                 - ::  x - y             X :: x*y (long)\n");
printf(
" t <i> :: x*i (small)       d <i> :: x/<i> (small)\n");
printf(
" D <m> <n> :: x[0..m]/y[0..n] (long)  2 <= n < m <= precision\n");
printf(
" ~ :: -x                    c ::  x (copy)          0 :: zero\n");
printf(
" s <i> :: shift by i        u ::  status(x)         # :: x <?> y\n");
printf(
" 2 :: x div2 y[1]           b ::  Bitpos(x)         r :: imnorm(x)\n");
printf(
" C10 :: x -> decimal       Cs :: decimal -> z       p :: upprec x,\n");
printf(
" m :: mp||int(x)            ? :: print options      q ::  quit testing\n");
printf(
" g :: globalmin(x)\n");
break;
	 default:   printf("Unsuitable input - ignored.\n");
       }
    }
 }
